From: "Darrick J. Wong" <darrick.wong@oracle.com>
To: david@fromorbit.com
Cc: fstests@vger.kernel.org, linux-btrfs@vger.kernel.org, xfs@oss.sgi.com
Subject: [PATCH v2 14/20] xfs: test clearing reflink inode flag
Date: Fri, 17 Jun 2016 09:40:25 -0700 [thread overview]
Message-ID: <20160617164025.GF5740@birch.djwong.org> (raw)
In-Reply-To: <146612805032.25024.3244105391915486280.stgit@birch.djwong.org>
Check that xfs_repair can clear the reflink inode flag.
v2: This is a reflink test; use _require_scratch_reflink
Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com>
---
tests/xfs/872 | 93 +++++++++++++++++++++++++++++++++++++++++++++++++++++
tests/xfs/872.out | 20 +++++++++++
tests/xfs/group | 1 +
3 files changed, 114 insertions(+)
create mode 100755 tests/xfs/872
create mode 100644 tests/xfs/872.out
diff --git a/tests/xfs/872 b/tests/xfs/872
new file mode 100755
index 0000000..e4c987e
--- /dev/null
+++ b/tests/xfs/872
@@ -0,0 +1,93 @@
+#! /bin/bash
+# FS QA Test No. 872
+#
+# Create 100 reflinked files, CoW them all, and see if xfs_repair will
+# clear the reflink flag. There was a buffer handling bug in xfs_repair
+# that (fortunately) triggered asserts in the rmap code when clearing
+# the reflink flag.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2016, Oracle and/or its affiliates. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ umount $SCRATCH_MNT > /dev/null 2>&1
+ rm -rf $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_supported_os Linux
+_supported_fs xfs
+_require_cp_reflink
+_require_scratch_reflink
+
+rm -f $seqres.full
+
+nr=128 # spanning at least one inode chunk tickles a bug in xfs_repair
+echo "Format filesystem"
+_scratch_mkfs >/dev/null 2>&1
+_scratch_mount >> $seqres.full
+
+echo "Create files"
+_pwrite_byte 0x66 0 1 $SCRATCH_MNT/file.0 >> $seqres.full
+seq 1 $nr | while read i; do
+ _cp_reflink $SCRATCH_MNT/file.0 $SCRATCH_MNT/file.$i
+done
+sync
+
+echo "Check files"
+for i in 0 $((nr / 2)) $nr; do
+ md5sum $SCRATCH_MNT/file.$i | _filter_scratch
+ $XFS_IO_PROG -c 'lsattr -v' $SCRATCH_MNT/file.$i | _filter_scratch
+done
+
+echo "CoW all files"
+seq 1 $nr | while read i; do
+ echo m >> $SCRATCH_MNT/file.$i
+done
+
+echo "Repair filesystem"
+_scratch_unmount
+_repair_scratch_fs >> $seqres.full
+_scratch_mount
+
+echo "Check files again"
+for i in 0 $((nr / 2)) $nr; do
+ md5sum $SCRATCH_MNT/file.$i | _filter_scratch
+ $XFS_IO_PROG -c 'lsattr -v' $SCRATCH_MNT/file.$i | _filter_scratch
+done
+
+echo "Done"
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/872.out b/tests/xfs/872.out
new file mode 100644
index 0000000..316cb0a
--- /dev/null
+++ b/tests/xfs/872.out
@@ -0,0 +1,20 @@
+QA output created by 872
+Format filesystem
+Create files
+Check files
+8fa14cdd754f91cc6554c9e71929cce7 SCRATCH_MNT/file.0
+[reflink] SCRATCH_MNT/file.0
+8fa14cdd754f91cc6554c9e71929cce7 SCRATCH_MNT/file.64
+[reflink] SCRATCH_MNT/file.64
+8fa14cdd754f91cc6554c9e71929cce7 SCRATCH_MNT/file.128
+[reflink] SCRATCH_MNT/file.128
+CoW all files
+Repair filesystem
+Check files again
+8fa14cdd754f91cc6554c9e71929cce7 SCRATCH_MNT/file.0
+[] SCRATCH_MNT/file.0
+0f17fd72b7bbf5bda0ff433e6d1fc118 SCRATCH_MNT/file.64
+[] SCRATCH_MNT/file.64
+0f17fd72b7bbf5bda0ff433e6d1fc118 SCRATCH_MNT/file.128
+[] SCRATCH_MNT/file.128
+Done
diff --git a/tests/xfs/group b/tests/xfs/group
index 0f94794..ca36ad6 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -304,3 +304,4 @@
869 auto quick clone
870 auto quick clone
871 auto quick clone
+872 auto quick clone
_______________________________________________
xfs mailing list
xfs@oss.sgi.com
http://oss.sgi.com/mailman/listinfo/xfs
next prev parent reply other threads:[~2016-06-17 16:40 UTC|newest]
Thread overview: 33+ messages / expand[flat|nested] mbox.gz Atom feed top
2016-06-17 1:46 [PATCH v6 00/20] xfstests: minor fixes for the reflink/dedupe tests Darrick J. Wong
2016-06-17 1:46 ` [PATCH 01/20] xfs/104: don't enospc when ag metadata overhead grows Darrick J. Wong
2016-06-17 1:46 ` [PATCH 02/20] tests: don't put loop control files on the scratch mount Darrick J. Wong
2016-06-17 1:46 ` [PATCH 03/20] xfs: test copy-on-write leftover recovery Darrick J. Wong
2016-06-17 1:46 ` [PATCH 04/20] xfs: test per-ag allocation accounting during truncate-caused refcountbt expansion Darrick J. Wong
2016-06-17 1:46 ` [PATCH 05/20] reflink: test interaction with swap files Darrick J. Wong
2016-06-17 1:46 ` [PATCH 06/20] xfs: test rmap behavior when multiple bmbt records map to a single rmapbt record Darrick J. Wong
2016-06-17 1:46 ` [PATCH 07/20] reflink: test changing sharers of a block while keeping refcount the same Darrick J. Wong
2016-06-17 1:46 ` [PATCH 08/20] xfs/122: don't break on old xfsprogs Darrick J. Wong
2016-06-17 1:46 ` [PATCH 09/20] xfs/122: fix test output to reflect latest xfsprogs Darrick J. Wong
2016-06-17 1:47 ` [PATCH 10/20] xfs/122: list the new log redo items Darrick J. Wong
2016-06-17 1:47 ` [PATCH 11/20] xfs: inject errors at various parts of the deferred op completion Darrick J. Wong
2016-06-17 16:39 ` [PATCH v2 " Darrick J. Wong
2016-06-17 1:47 ` [PATCH 12/20] xfs/235: fix logic errors when checking rmap usage after failures Darrick J. Wong
2016-06-17 1:47 ` [PATCH 13/20] xfs/229: require 3GB of space Darrick J. Wong
2016-06-17 1:47 ` [PATCH 14/20] xfs: test clearing reflink inode flag Darrick J. Wong
2016-06-17 16:40 ` Darrick J. Wong [this message]
2016-06-17 1:47 ` [PATCH 15/20] xfstests: fix unreferenced variables in generic/186 and generic/187 Darrick J. Wong
2016-06-17 1:47 ` [PATCH 16/20] reflink: test cross-mountpoint reflink and dedupe Darrick J. Wong
2016-07-04 6:51 ` Eryu Guan
2016-07-04 19:11 ` Darrick J. Wong
2016-06-17 1:47 ` [PATCH 17/20] generic/204: increase log size for rmap/reflink Darrick J. Wong
2016-06-17 1:47 ` [PATCH 18/20] xfs/128: use $XFS_FSR_PROG instead of xfs_fsr directly Darrick J. Wong
2016-06-17 1:48 ` [PATCH 19/20] xfs: run xfs_repair at the end of each test Darrick J. Wong
2016-07-05 3:56 ` Eryu Guan
2016-07-05 4:11 ` Darrick J. Wong
2016-07-06 23:13 ` Dave Chinner
2016-07-06 23:49 ` Darrick J. Wong
2016-06-17 1:48 ` [PATCH 20/20] xfs: scrub fs (if still mounted) at the end of the test Darrick J. Wong
2016-06-29 3:36 ` [PATCH 21/20] xfs/128: cycle_mount the scratch device, not the test device Darrick J. Wong
2016-07-05 4:31 ` [PATCH v6 00/20] xfstests: minor fixes for the reflink/dedupe tests Eryu Guan
2016-07-06 22:44 ` Darrick J. Wong
2016-07-13 5:28 ` Darrick J. Wong
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20160617164025.GF5740@birch.djwong.org \
--to=darrick.wong@oracle.com \
--cc=david@fromorbit.com \
--cc=fstests@vger.kernel.org \
--cc=linux-btrfs@vger.kernel.org \
--cc=xfs@oss.sgi.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox